"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Pipeline = void 0;
var Pipeline = /** @class */ (function () {
    function Pipeline() {
        var handlers = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            handlers[_i] = arguments[_i];
        }
        this.handlers = [];
        this.handlers = handlers;
    }
    Pipeline.prototype.add = function (handler) {
        this.handlers.push(handler);
        return this;
    };
    Pipeline.prototype.execute = function (value) {
        return this.pipeline(function () { return value; })(value);
    };
    Pipeline.prototype.pipeline = function (initiator) {
        return this.handlers.reduce(function (previous, current) { return function (value) { return current(previous(value)); }; }, initiator);
    };
    return Pipeline;
}());
exports.Pipeline = Pipeline;
//# sourceMappingURL=Pipeline.js.map