"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Strings = void 0;
var Logging_1 = __importDefault(require("./Logging"));
var logger = Logging_1.default.extend('strings');
exports.Strings = {
    format: function (message) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        logger.debug('format', message, args);
        return args.reduce(function (previous, current, index) {
            var regex = new RegExp("\\{" + index + "\\}", 'gm');
            return previous.replace(regex, current);
        }, message);
    },
    formatObject: function (message, object) {
        var keys = Object.keys(object);
        logger.debug('formatObject', message, keys);
        return keys.reduce(function (previous, current, index) {
            var regex = new RegExp("\\{" + current + "\\}", 'igm');
            return previous.replace(regex, object[current]);
        }, message);
    },
};
//# sourceMappingURL=Strings.js.map