"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Walk = exports.WalkType = void 0;
var types_1 = require("@nofrills/types");
var Logging_1 = __importDefault(require("./Logging"));
var logger = Logging_1.default.extend('walk');
var WalkType;
(function (WalkType) {
    WalkType[WalkType["Array"] = 0] = "Array";
    WalkType[WalkType["Object"] = 1] = "Object";
})(WalkType = exports.WalkType || (exports.WalkType = {}));
var ATAT = /** @class */ (function () {
    function ATAT() {
    }
    ATAT.WalkArray = function (value, interceptor) {
        return value.map(function (element, index) {
            logger.debug('WalkArray', element, index);
            if (interceptor) {
                interceptor(WalkType.Array, element, [index.toString()]);
            }
            if (types_1.Is.object(element)) {
                return ATAT.WalkObject(element, [], interceptor);
            }
            else if (types_1.Is.array(element)) {
                return ATAT.WalkArray(element, interceptor);
            }
            return element;
        });
    };
    ATAT.WalkObject = function (value, path, interceptor) {
        Object.keys(value).forEach(function (key) {
            path.push(key);
            try {
                var current = value[key];
                logger.debug('WalkObject', key, current, path);
                if (interceptor) {
                    interceptor(WalkType.Object, current, path);
                }
                if (types_1.Is.array(current)) {
                    ATAT.WalkArray(current, interceptor);
                }
                else if (types_1.Is.object(current)) {
                    ATAT.WalkObject(current, path, interceptor);
                }
            }
            finally {
                path.pop();
            }
        });
        return value;
    };
    return ATAT;
}());
exports.Walk = function (value, interceptor) {
    if (types_1.Is.array(value)) {
        return ATAT.WalkArray(value, interceptor);
    }
    else if (types_1.Is.object(value)) {
        return ATAT.WalkObject(value, [], interceptor);
    }
    return value;
};
//# sourceMappingURL=Walk.js.map